var EuclidRes;
var length;

/*******************************************************************************
   Legnagyobb kzs oszt meghatrozsa az euklideszi algoritmus segtsgvel
*******************************************************************************/

function Euclid(a, b) {
   var r;

   if (a < b) {
      a ^= b;
      b ^= a;
      a ^= b;
   }
   while (b) {
      r = a % b;
      EuclidRes[length++] = a;
      EuclidRes[length++] = b;
      EuclidRes[length++] = r;
      EuclidRes[length++] = Math.floor(a / b);
      a = b;
      b = r;
   }
   return a;
}

function PrintGCDResult(a, b, gcd) {
   var last;

   top.frames[2].document.write("<table border=0 cellspacing=0 cellpadding=3 bgcolor='#f0f0f0'><tr><td><table border=0 cellspacing=0 cellpadding=3 bgcolor='#ffffff'><tr><td><table border=0 cellspacing=0 cellpadding=3>");
   top.frames[2].document.write("<tr><td bgcolor='#f0f0f0' width=33%><b>a<\/b><\/td><td bgcolor='#f0f0f0' width=33%><b>b<\/b><\/td><td bgcolor='#f0f0f0'><sup>&nbsp;<\/sup><\/td><td bgcolor='#f0f0f0' width=33%><b>r<\/b><\/td><\/tr>");
   last = (gcd ? EuclidRes.length : EuclidRes.length - 4);
   for (i = 0; i < last; i += 4) {
      top.frames[2].document.write("<tr><td>" + EuclidRes[i] + "<\/td><td>" + EuclidRes[i + 1] + "<\/td><td><sup>&nbsp;<\/sup><\/td><td>" + EuclidRes[i + 2] + "<\/td><\/tr>");
   }
   top.frames[2].document.write("<\/table><\/td><\/tr><\/table><\/td><\/tr><\/table>");
}

function GCD(a, b) {
   var res;

   if (a == "" || b == "") {
      alert("Valamennyi mezt ki kell tlteni!");
   } else {
      a *= 1;
      b *= 1;
      if (a <= 0 || b <= 0) {
         alert("Minden meznek pozitv egsznek kell lennie!");
      } else {
         EuclidRes = new Array();
         length = 0;
         top.frames[2].document.write("<head><style type='text/css'>td { font-family: monospace } body { font-family: sans-serif; text-align: justify }<\/style><\/head><body>");
         res = Euclid(a, b);
         PrintGCDResult(a, b, true);
         top.frames[2].document.write("<font face='Arial CE,Arial,Helvetica,Helv'><p>Eredmny:<p style='margin-left:4%'>LNKO(" + a + "; " + b +  ") = " + res + "<p>");
         if (res == 1) {
            top.frames[2].document.write("<b>" + a + "<\/b> s <b>" + b + "<\/b> relatv prmek.");
         } else if (res == b) {
            top.frames[2].document.write("<b>" + b + "<\/b> osztja a <b>" + a + "<\/b> szmnak.");
         } else if (res == a) {
            top.frames[2].document.write("<b>" + a + "<\/b> osztja a <b>" + b + "<\/b> szmnak.");
         }
         top.frames[2].document.write("<\/font><\/body>");
         top.frames[2].document.close();
      }
   }
}
