/*************************************************************************************
   Ez a programkd, s a belle fordthat Java applet oktatsi clokat szolgl,
   szabadon felhasznlhat s talakthat. Az osztlyok, vltozk s tagfggvnyek
   dokumentcijt lsd a 'doc/rsademodoc.html' file-ban.

   A PROGRAM AZ RSA ELJRST HIVATOTT RSZLETESEN BEMUTATNI, GY KRIPTOGRFIAI
   FELHASZNLSA NEM JAVASOLT! BRMILYEN KR (ANYAGI S/VAGY ERKLCSI), AMI AZ
   ELLENJAVALT FELHASZNLSI MDBL ERED, KIZRLAG A FELHASZNLT TERHELI.

   Barta ron, 2004
   dominator@emil.hu

   Informnci- s hrkzlselmlet
   Beadand vizsgafeladat
   2003/2004 szi flv
**************************************************************************************/

import java.awt.*;
import java.awt.event.*;

class CancelButton extends Panel implements MouseListener, MouseMotionListener {
   private static final int CBSTATE_OUT      = 1;
   private static final int CBSTATE_OVER     = 2;
   private int x, y, h, w, state;
   private boolean visible;
   private RSAGUI parent;

   public CancelButton(RSAGUI parent) {
      visible = false;
      state = CBSTATE_OUT;
      this.parent = parent;
      addMouseListener(this);
      addMouseMotionListener(this);
   }

   public void Show(int x, int y, int w, int h) {
      this.x = x;
      this.y = y;
      this.w = w;
      this.h = h;
      this.visible = true;
   }

   public void Hide() {
      this.visible = false;
   }

   public void update(Graphics g) {
      if (visible) {
         g.setColor(Color.black);
         g.drawRoundRect(x, y, w, h, 2, 2);
         switch (state) {
            case CBSTATE_OUT:
               g.setColor(new Color(240, 240, 255));
               break;
            case CBSTATE_OVER:
               g.setColor(new Color(220, 220, 255));
               break;
         }
         g.fillRoundRect(x, y, w, h, 2, 2);
         g.setColor(Color.blue);
         g.setFont(new Font("Helvetica", Font.BOLD, 14));
         g.drawString("Mgse", x + 10, y + 15);
      }
   }

   public void paint(Graphics g) {
   }

   public void mouseClicked(MouseEvent e) {
   }

   public void mousePressed(MouseEvent e) {
   }

   public void mouseReleased(MouseEvent e) {
      parent.cancelled = true;
   }

   public void mouseEntered(MouseEvent e) {
   }

   public void mouseExited(MouseEvent e) {
   }

   public void mouseMoved(MouseEvent evt) {
      if (visible) {
         evt.consume();
         if (evt.getX() > x && evt.getX() < x + w && evt.getY() > y && evt.getY() < y + h) {
            state = CBSTATE_OVER;
         } else {
            state = CBSTATE_OUT;
         }
      }
   }

   public void mouseDragged(MouseEvent e) {
   }
};

class RSAGUI
   extends Panel
   implements ItemListener,
              ActionListener,
              MouseListener,
              MouseMotionListener,
              KeyListener,
              TextListener {

   private static final int CM_RANDOM     = 0;
   private static final int CM_MOUSEMOVE  = 1;
   private static final int CM_KEYPRESS   = 2;

   private CancelButton cancel;
   private Panel panel, // a program kezeli felletnek vezrlelemei
                 keyPanel; // a billenytletsekkel trtn vletlenszm-generls vezrlelemei
   private Checkbox cbMaxBitDepth,
                    cbLimitPrimeLength,
                    cbRandom,
                    cbMouseMove,
                    cbKeyPress;
   private TextField tfMinVal,
                     tfMaxVal,
                     tfToHide,
                     tfToHideCode,
                     tfHidden,
                     tfOriginalCode,
                     tfOriginal,
                     tfKeyInput;
   private Button btnGeneratePrimes,
                  btnGenerateE,
                  btnEncrypt,
                  btnDecrypt,
                  btnCancel;
   public Label prime1, prime2,
                n, m, e, d,
                multiplier, to_try, key_code;
   private RSAdemo rsa;
   private int RandomE = 0,
               coeff,
               CreationMethod,
               mouseX,
               mouseY,
               keyPressed;
   public boolean startGeneratingE, cancelled;



   public RSAGUI(RSAdemo rsademo) {
      Label l;
      CheckboxGroup group1 = new CheckboxGroup(),
                    group2 = new CheckboxGroup();

      rsa = rsademo;
      cancel = new CancelButton(this);
      startGeneratingE = false;
      cancelled = false;
      addMouseListener(this);
      addMouseMotionListener(this);
      CreationMethod = CM_MOUSEMOVE;

/////////////////////////////
// keyPanel elemei
/////////////////////////////
      keyPanel = new Panel();
      keyPanel.setLayout(new GridLayout(6, 1));
      keyPanel.setVisible(false);
      add("West", keyPanel);
// 1. sor
      l = new Label("Krem, ssn le ssze-vissza nhny billentyt!");
      l.setFont(new Font("Helvetica", Font.BOLD, 20));
      l.setForeground(Color.blue);
      keyPanel.add(l);
// 2. sor
      tfKeyInput = new TextField();
      tfKeyInput.addKeyListener(this);
      keyPanel.add(tfKeyInput);
// 3. sor
      key_code = new Label("Billentykd:");
      key_code.setFont(new Font("Courier", Font.PLAIN, 12));
      keyPanel.add(key_code);
// 4. sor
      multiplier = new Label("Szorz:");
      multiplier.setFont(new Font("Courier", Font.PLAIN, 12));
      keyPanel.add(multiplier);
// 5. sor
      to_try = new Label("Prba:");
      to_try.setFont(new Font("Courier", Font.BOLD, 16));
      keyPanel.add(to_try);
// 6. sor
      btnCancel = new Button("Mgse");
      btnCancel.addActionListener(this);
      keyPanel.add(btnCancel);
// GridLayout vge


/////////////////////////////
// panel elemei
/////////////////////////////
      panel = new Panel();
      panel.setLayout(new GridLayout(14, 4, 15, 3));
      add("East", panel);

// 1. sor
      l = new Label("Prmek ellltsa");
      l.setFont(new Font("Helvetica", Font.BOLD, 12));
      panel.add(l);

      l = new Label();
      panel.add(l);

      l = new Label();
      panel.add(l);

      l = new Label("Vletlen szm generlsa");
      l.setFont(new Font("Helvetica", Font.BOLD, 12));
      panel.add(l);

// 2. sor
      l = new Label("Prmek generlsa:");
      l.setAlignment(Label.RIGHT);
      panel.add(l);

      cbMaxBitDepth = new Checkbox("Maximlis rtk (" + rsa.rsaMaxInt + ")", group1, true);
      cbMaxBitDepth.addItemListener(this);
      panel.add(cbMaxBitDepth);

      l = new Label("Vletlengenerls:");
      l.setAlignment(Label.RIGHT);
      panel.add(l);

      cbRandom = new Checkbox("Random-genertorral", group2, false);
      cbRandom.addItemListener(this);
      panel.add(cbRandom);

// 3. sor
      l = new Label();
      l.setAlignment(Label.RIGHT);
      panel.add(l);

      cbLimitPrimeLength = new Checkbox("Intervallumban:", group1, false);
      cbLimitPrimeLength.addItemListener(this);
      panel.add(cbLimitPrimeLength);

      l = new Label();
      l.setAlignment(Label.RIGHT);
      panel.add(l);

      cbMouseMove = new Checkbox("Egrmozgatssal", group2, true);
      cbMouseMove.addItemListener(this);
      panel.add(cbMouseMove);

// 4. sor
      l = new Label("Legalbb:");
      l.setAlignment(Label.RIGHT);
      panel.add(l);

      tfMinVal = new TextField();
      tfMinVal.setEnabled(false);
      panel.add(tfMinVal);

      l = new Label();
      l.setAlignment(Label.CENTER);
      panel.add(l);

      cbKeyPress = new Checkbox("Billenty letsekkel", group2, false);
      cbKeyPress.addItemListener(this);
      panel.add(cbKeyPress);

// 5. sor
      l = new Label("Legfeljebb:");
      l.setAlignment(Label.RIGHT);
      panel.add(l);

      tfMaxVal = new TextField();
      tfMaxVal.setEnabled(false);
      panel.add(tfMaxVal);

      l = new Label();
      l.setAlignment(Label.CENTER);
      panel.add(l);

      l = new Label();
      l.setAlignment(Label.CENTER);
      panel.add(l);

// 6. sor
      l = new Label();
      l.setAlignment(Label.CENTER);
      panel.add(l);

      btnGeneratePrimes = new Button("Prmek ellltsa");
      btnGeneratePrimes.addActionListener(this);
      panel.add(btnGeneratePrimes);

      l = new Label();
      l.setAlignment(Label.CENTER);
      panel.add(l);

      btnGenerateE = new Button("Az \"e\" szm ellltsa");
      btnGenerateE.addActionListener(this);
      panel.add(btnGenerateE);

// 7. sor
      l = new Label();
      l.setAlignment(Label.CENTER);
      panel.add(l);

      l = new Label();
      l.setAlignment(Label.CENTER);
      panel.add(l);

      l = new Label();
      l.setAlignment(Label.CENTER);
      panel.add(l);

      l = new Label();
      l.setAlignment(Label.CENTER);
      panel.add(l);

// 8. sor
      l = new Label("A rejteni kvnt szveg:");
      l.setFont(new Font("Helvetica", Font.BOLD, 12));
      panel.add(l);

      l = new Label("p1 = ");
      l.setAlignment(Label.RIGHT);
      l.setForeground(Color.red);
      panel.add(l);

      prime1 = new Label();
      prime1.setForeground(Color.red);
      prime1.setFont(new Font("Courier", Font.PLAIN, 12));
      panel.add(prime1);

      l = new Label("Titkos szveg megfejtse");
      l.setFont(new Font("Helvetica", Font.BOLD, 12));
      panel.add(l);

// 9. sor
      tfToHide = new TextField();
      tfToHide.setEnabled(false);
      panel.add(tfToHide);

      l = new Label("p2 = ");
      l.setAlignment(Label.RIGHT);
      l.setForeground(Color.red);
      panel.add(l);

      prime2 = new Label();
      prime2.setForeground(Color.red);
      prime2.setFont(new Font("Courier", Font.PLAIN, 12));
      panel.add(prime2);

      btnDecrypt = new Button("FEJTS!");
      btnDecrypt.addActionListener(this);
      panel.add(btnDecrypt);

// 10. sor
      l = new Label("A szveg kdja:");
      panel.add(l);

      l = new Label("n = p1 * p2 = ");
      l.setAlignment(Label.RIGHT);
      l.setForeground(new Color(0, 128, 0));
      panel.add(l);

      n = new Label();
      n.setForeground(new Color(0, 128, 0));
      n.setFont(new Font("Courier", Font.PLAIN, 12));
      panel.add(n);

      l = new Label("Az eredeti szveg kdja:");
      panel.add(l);

// 11. sor
      tfToHideCode = new TextField();
      panel.add(tfToHideCode);

      l = new Label("m = (p1 - 1) * (p2 - 1) = ");
      l.setAlignment(Label.RIGHT);
      l.setForeground(Color.red);
      panel.add(l);

      m = new Label();
      m.setForeground(Color.red);
      m.setFont(new Font("Courier", Font.PLAIN, 12));
      panel.add(m);

      tfOriginalCode = new TextField();
      panel.add(tfOriginalCode);

// 12. sor
      btnEncrypt = new Button("REJTS!");
      btnEncrypt.addActionListener(this);
      panel.add(btnEncrypt);

      l = new Label();
      l.setAlignment(Label.CENTER);
      panel.add(l);

      l = new Label();
      l.setAlignment(Label.CENTER);
      panel.add(l);

      l = new Label("Az eredeti szveg:");
      panel.add(l);

// 13. sor
      l = new Label("A titkostott szveg kdja:");
      panel.add(l);

      l = new Label("e = ");
      l.setAlignment(Label.RIGHT);
      l.setForeground(new Color(0, 128, 0));
      panel.add(l);

      e = new Label();
      e.setForeground(new Color(0, 128, 0));
      e.setFont(new Font("Courier", Font.PLAIN, 12));
      panel.add(e);

      tfOriginal = new TextField();
      tfOriginal.addTextListener(this);
      panel.add(tfOriginal);

// 14. sor
      tfHidden = new TextField();
      panel.add(tfHidden);

      l = new Label("d = e ^ -1 mod m = ");
      l.setAlignment(Label.RIGHT);
      l.setForeground(Color.red);
      panel.add(l);

      d = new Label();
      d.setForeground(Color.red);
      d.setFont(new Font("Courier", Font.PLAIN, 12));
      panel.add(d);

      l = new Label();
      panel.add(l);

// GridLayout vge


      clearAllFields();
   }


   public void setCreationMethod(Object choice) {
      if (choice == cbRandom) {
         CreationMethod = CM_RANDOM;
      } else if (choice == cbMouseMove) {
         CreationMethod = CM_MOUSEMOVE;
      } else if (choice == cbKeyPress) {
         CreationMethod = CM_KEYPRESS;
      }
   }

   private void clearEFields() {
      e.setText("");
      d.setText("");
      btnEncrypt.setEnabled(false);
      btnDecrypt.setEnabled(false);
      tfHidden.setText("");
      tfOriginal.setText("");
      tfOriginalCode.setText("");
   }

   private void clearAllFields() {
      prime1.setText("");
      prime2.setText("");
      n.setText("");
      m.setText("");
      clearEFields();
      btnGenerateE.setEnabled(false);
      tfOriginal.setText("");
      tfOriginalCode.setText("");
   }

   private void setCryptFields() {
      e.setText(Integer.toString(rsa.e));
      d.setText(Integer.toString(rsa.d));
      tfToHide.setEnabled(true);
      tfToHide.addTextListener(this);
      btnEncrypt.setEnabled(tfToHide.getText().length() > 0 ? true : false);
      btnDecrypt.setEnabled(false);
      tfHidden.setText("");
      tfOriginal.setText("");
      tfOriginalCode.setText("");
   }

   public void itemStateChanged(ItemEvent evt) {
      Object obj = evt.getSource();

      // Maximlis rtk
      if (obj == cbMaxBitDepth) {
         tfMinVal.setEnabled(false);
         tfMaxVal.setEnabled(false);
         clearAllFields();
         rsa.resetRSA();
         return;
      }

      // Prm rtknek korltozsa
      if (obj == cbLimitPrimeLength) {
         tfMinVal.setEnabled(true);
         tfMaxVal.setEnabled(true);
         clearAllFields();
         rsa.resetRSA();
         return;
      }

      // Random-genertorral || Egrmozgatssal || Billenty letsekkel
      if (obj == cbRandom || obj == cbMouseMove || obj == cbKeyPress) {
         setCreationMethod(obj);
         clearEFields();
         return;
      }
   }

   public void actionPerformed(ActionEvent evt) {
      Object obj = evt.getSource();
      int minVal,
          maxVal;
      Integer iMinVal,
              iMaxVal;
      int i = 0;

      // Prmek ellltsa
      if (obj == btnGeneratePrimes) {
         if (cbLimitPrimeLength.getState()) {
            try {
            	iMinVal = Integer.valueOf(tfMinVal.getText());
            } catch (NumberFormatException ex) {
               return;
            }
            try {
            	iMaxVal = Integer.valueOf(tfMaxVal.getText());
            } catch (NumberFormatException ex) {
               return;
            }
            minVal = iMinVal.intValue();
            maxVal = iMaxVal.intValue();
            if (minVal >= maxVal - 80 || minVal < 3 || maxVal > rsa.rsaMaxInt) {
               return;
            }
            rsa.GeneratePrimes(minVal, maxVal);
         } else {
            rsa.GeneratePrimes();
         }
         n.setText(Integer.toString(rsa.n));
         m.setText(Integer.toString(rsa.m));
         if (rsa.m > getSize().width + getSize().height) {
            cbMouseMove.setEnabled(true);
            cbKeyPress.setEnabled(true);
         } else {
            cbMouseMove.setEnabled(false);
            cbKeyPress.setEnabled(false);
            cbRandom.setState(true);
         }
         btnGenerateE.setEnabled(true);
         clearEFields();
         return;
      }

      // Az "e" szm ellltsa
      if (obj == btnGenerateE) {
         if (cbRandom.getState()) { // Random-genertorral
            try {
               rsa.GenerateE();
            } catch (Exception ex) {
               return;
            }
            setCryptFields();
            return;
         } else if (cbMouseMove.getState() || cbKeyPress.getState()) { // Egrmozgatssal || Billenty letsekkel
            if (rsa.n != 0) {
               RandomE = 0;
               startGeneratingE = true;
               panel.setVisible(false);
               if (cbMouseMove.getState()) {
                  cancel.Show(20, 130, 65, 21);
               }
               if (cbKeyPress.getState()) {
                  keyPanel.setVisible(true);
                  tfKeyInput.setText("");
                  validate();
                  repaint();
               }
            }
            return;
         }
      }

      // REJTS!
      if (obj == btnEncrypt) {
         tfHidden.setText(rsa.doEncryptText(tfToHide.getText()));
         btnDecrypt.setEnabled(rsa.numChars > 0 ? true : false);
         tfOriginal.setText("");
         tfOriginalCode.setText("");
      }

      // FEJTS!
      if (obj == btnDecrypt) {
         tfOriginal.setText(rsa.doDecryptText());
      }

      // Mgse
      if (obj == btnCancel) {
         keyPanel.setVisible(false);
         key_code.setText("Billentykd: ");
         multiplier.setText("Szorz: ");
         to_try.setText("Prba: ");
         startGeneratingE = false;
         panel.setVisible(true);
         clearEFields();
      }
   }

   private void createRandomNumber(int base) {
      coeff = rsa.m < 10000 ? 1 : (int)Math.pow(10, (int)(Math.log(rsa.m) / Math.log(10)) - (CreationMethod == CM_KEYPRESS ? 3 : 4)) - 1;

      RandomE += ( coeff * base - 1 ) / 2;
      if (RandomE < 0) {   // tlcsordult...
         RandomE = 0;
      }
   }

   public void mouseMoved(MouseEvent evt) {
      if (startGeneratingE && CM_MOUSEMOVE == CreationMethod) {
         evt.consume();
         mouseX = evt.getX();
         mouseY = evt.getY();
         createRandomNumber(mouseX + mouseY);
         repaint();
         if (RandomE >= rsa.m) {
            if (rsa.GenerateE(RandomE)) {
               startGeneratingE = false;
               panel.setVisible(true);
               setCryptFields();
               return;
            } else {
               RandomE = 0;
            }
         }
         cancel.mouseMoved(evt);
         repaint();
      }
   }

   public void keyPressed(KeyEvent evt) {
      if (startGeneratingE && CM_KEYPRESS == CreationMethod) {
         keyPressed = evt.getKeyChar();
         createRandomNumber(keyPressed);
         key_code.setText("Billentykd: " + Integer.toString(keyPressed));
         multiplier.setText("Szorz: " + Integer.toString(coeff));
         to_try.setText("Prba: " + Integer.toString(RandomE));
         tfKeyInput.setText("");
         repaint();
         if (RandomE >= rsa.m) {
            if (rsa.GenerateE(RandomE)) {
               keyPanel.setVisible(false);
               key_code.setText("Billentykd: ");
               multiplier.setText("Szorz: ");
               to_try.setText("Prba: ");
               startGeneratingE = false;
               panel.setVisible(true);
               setCryptFields();
               return;
            } else {
               RandomE = 0;
            }
         }
      }
   }

   public void textValueChanged(TextEvent evt) {
      TextField obj = (TextField)evt.getSource();
      String text;
      char textCh[];
      String txtNumCode = new String();

      if (obj == tfToHide || obj == tfOriginal) {
         text = obj.getText();
         textCh = text.toCharArray();
         for (int i = 0; i < text.length(); i++) {
            txtNumCode += Integer.toString((int)textCh[i]) + " ";
         }
         if (obj == tfToHide) {
            tfToHideCode.setText(txtNumCode);
            tfToHideCode.setCaretPosition(txtNumCode.length());
            btnDecrypt.setEnabled(false);
            btnEncrypt.setEnabled(text.length() > 0 ? true : false);
         } else {
            tfOriginalCode.setText(txtNumCode);
            tfOriginalCode.setCaretPosition(txtNumCode.length());
         }
      }
      if (obj == tfMinVal || obj == tfMaxVal) {
         clearAllFields();
         rsa.resetRSA();
      }
   }

   public void paint(Graphics g) {
      if (startGeneratingE && CM_MOUSEMOVE == CreationMethod) {
         g.setFont(new Font("Helvetica", Font.BOLD, 20));
         g.setColor(Color.blue);
         g.drawString("Krem, mozgassa az egeret a fekete keretben!", 20, 30);
      }
   }

   public void update(Graphics g) {
      if (startGeneratingE) {
         if (CM_MOUSEMOVE == CreationMethod) {
            g.setColor(Color.white);
            g.fillRect(15, 40, 190, 65);
            g.setColor(Color.black);
            g.setFont(new Font("Courier", Font.PLAIN, 12));
            g.drawString("Egr X: " + Integer.toString(mouseX), 20, 50);
            g.drawString("Egr Y: " + Integer.toString(mouseY), 20, 60);
            g.drawString("Szorz: " + Integer.toString(coeff), 20, 70);
            g.setFont(new Font("Courier", Font.BOLD, 16));
            g.drawString("Prba: " + Integer.toString(RandomE), 20, 100);
            g.drawRect(0, 0, getSize().width - 1, getSize().height - 1);
            cancel.update(g);
         }
      } else {
         g.setColor(Color.white);
         g.drawRect(0, 0, getSize().width - 1, getSize().height - 1);
      }
   }

   public void mouseDragged(MouseEvent e) {
   }

   public void mouseClicked(MouseEvent e) {
   }

   public void mousePressed(MouseEvent e) {
   }

   public void mouseReleased(MouseEvent e) {
      cancel.mouseReleased(e);
      if (cancelled) {
         startGeneratingE = false;
         panel.setVisible(true);
         clearEFields();
         cancelled = false;
      }
      repaint();
   }

   public void mouseEntered(MouseEvent e) {
   }

   public void mouseExited(MouseEvent e) {
   }

   public void keyTyped(KeyEvent evt) {
   }

   public void keyReleased(KeyEvent evt) {
   }
}
