/*************************************************************************************
   Ez a programkd, s a belle fordthat Java applet oktatsi clokat szolgl,
   szabadon felhasznlhat s talakthat. Az osztlyok, vltozk s tagfggvnyek
   dokumentcijt lsd a 'doc/rsademodoc.html' file-ban.

   A PROGRAM AZ RSA ELJRST HIVATOTT RSZLETESEN BEMUTATNI, GY KRIPTOGRFIAI
   FELHASZNLSA NEM JAVASOLT! BRMILYEN KR (ANYAGI S/VAGY ERKLCSI), AMI AZ
   ELLENJAVALT FELHASZNLSI MDBL ERED, KIZRLAG A FELHASZNLT TERHELI.

   Barta ron, 2004
   dominator@emil.hu

   Informnci- s hrkzlselmlet
   Beadand vizsgafeladat
   2003/2004 szi flv
**************************************************************************************/

import java.awt.*;
import java.applet.*;
import java.lang.*;
import java.util.*;

class Primes {
   int rangeMin,  // intervallum als hatra
       rangeMax;  // intervallum fels hatra

   Primes() {
   }

   public boolean isPrime(int x) {
      int i = 3,
          sqrt_x = (int)Math.sqrt((double)x);

      if (x % 2 == 0) return false;
      while (x % i != 0 && i <= sqrt_x) {
         i += 2;
      }
      return (i <= sqrt_x ? false : true);
   }

   public int generatePrime() {
      int res;
      double sqrt_max = Math.sqrt((double)(Integer.MAX_VALUE - 1));

      // elmletileg itt eshet vgtelen ciklusba; gyakorlatilag nem
      while (!isPrime(res = (int)(Math.random() * sqrt_max)));

      return res;
   }

   public int generatePrime(int rangeMin, int rangeMax) {
      int res;

      // elmletileg itt eshet vgtelen ciklusba; gyakorlatilag nem
      while (!isPrime(res = (int)(Math.random() * (rangeMax - rangeMin) + rangeMin)));

      return res;
   }
}

class GreatNumPow {

   GreatNumPow () {}

   private int PowerOfTwo(int e) {
      int i = 0;

      while (e >> i > 1) i++;

      return i;
   }

   private double log2(int x) {
      return Math.log(x) / Math.log(2);
   }

   private boolean memberOf(int a[], int item) {
      int i = 0, len = (int)log2(Integer.MAX_VALUE);

      while (i < len && a[i] != item) {
         i++;
      }
      return i < len ? true : false;
   }

   public int doGreatNumPow(int x, int e, int n) {
      int i = 0, j, base = e, greatest, k = 0;
      long part_res;
      int Binary[] = new int[(int)log2(Integer.MAX_VALUE)]; // a kitev ketthatvny-felbontst trolja
      long PowMod[] = new long[(int)log2(Integer.MAX_VALUE)]; // az sszes x^ketthatvny (mod n) rtket trolja
      long PartRes[] = new long[(int)log2(Integer.MAX_VALUE)]; // a szksges kett-hatvnyra emelt, (mod n) vett hatvnyokat trolja

      greatest = PowerOfTwo(base);
      while (base > 0) {
         Binary[i++] = (1 << PowerOfTwo(base));
         base -= (1 << PowerOfTwo(base));
      }
      PowMod[0] = x;
      if (memberOf(Binary, 1)) {
         PartRes[k++] = PowMod[0];
      }
      for (j = 1; j <= greatest; j++) {
         PowMod[j] = PowMod[j - 1] * PowMod[j - 1];
         PowMod[j] %= n;
         if (memberOf(Binary, 1 << j)) {
            PartRes[k++] = PowMod[j];
         }
      }
      part_res = PartRes[0];
      for (j = 1; j < k; j++) {
         part_res *= PartRes[j];
         part_res %= (long)n;
      }
      return (int)part_res;
   }

}

class Euclid {
   Euclid() {}

   /*
      Legnagyobb kzs oszt meghatrozsa az euklideszi algoritmus segtsgvel
   */
   public int GCD(long a, long b) {
      long r;

      // ha 'b' nagyobb, mint 'a', akkor a kt szmot fel kell cserlni
      if (a < b) {
         a ^= b;
         b ^= a;
         a ^= b;
      }

      while (b > 0) {
         r = a % b;
         a = b;
         b = r;
      }

      return (int)a;
   }

   /*
      Az e szm inverznek meghatrozsa
   */
   public int Invert(long e, long m) {
      double e0 = (long)e,
             m0 = (long)m;
      long t = 1,
          q = (long)(m0 / e0),
          r = (long)(m0 - q * e0),
          temp,
          t0 = 0;

      if (e == 0 || m == 0) return -1;

      while (r > 0) {
         temp = t0 - q * t;
         if (temp >= 0) temp = temp % m;
         if (temp < 0) temp = m - ((-temp) % m);
         t0 = t;
         t = temp;

         m0 = e0;
         e0 = r;
         q = (long)(m0 / e0);
         r = (long)(m0 - q * e0);
      }
      if ((long)e0 != 1) {
         return -1;
      } else {
         return (int)t;
      }
   }

}

public class RSAdemo extends Applet {
   RSAGUI gui;
   Primes primes;
   Euclid euc;
   GreatNumPow gnp;
   public int p1, p2, n = 0, m, e, d;
   public int encryptedText[],
              numChars = 0,
              rsaMaxInt = (int)Math.sqrt((double)(Integer.MAX_VALUE - 1));
               
   public RSAdemo() {
      setBackground(Color.white);
      resetRSA();
   }

   public void init() {
      gui = new RSAGUI(this);
      primes = new Primes();
      euc = new Euclid();
      gnp = new GreatNumPow();

      setLayout(new FlowLayout());
      add("North", gui);
   }

   public int generateRandomE(int range, int m) {
      long res;

      while (euc.GCD(res = (int)(Math.random() * range + 1), (long)m) != 1);

      return (int)res;
   }

   public String getAppletInfo() {
      return
      "RSA Demo Java Applet\n\n" +
      "A PROGRAM AZ RSA ELJRST HIVATOTT RSZLETESEN\n" +
      "BEMUTATNI, GY KRIPTOGRFIAI FELHASZNLSA NEM JAVASOLT!\n" +
      "BRMILYEN KR (ANYAGI S/VAGY ERKLCSI), AMI AZ\n" +
      "ELLENJAVALT FELHASZNLSI MDBL ERED,\n" +
      "KIZRLAG A FELHASZNLT TERHELI.\n\n" +
      "Barta ron, 2004\n" +
      "dominator@emil.hu\n\n" +
      "Informnci- s hrkzlselmlet\n" +
      "Beadand vizsgafeladat\n" +
      "2003/2004 szi flv\n";
   }

   private void CalculateProducts() {
      n = p1 * p2;
      m = (p1 - 1) * (p2 - 1);
   }

   public synchronized int generateOnePrime(int max, int offset, Label lPrime) {
      int prime;

      lPrime.setForeground(Color.black);
      while (!primes.isPrime(prime = (int)(Math.random() * max + offset))) {
         lPrime.setText(Integer.toString(prime));
         try {
            wait(50);
         } catch (Exception e) {
         }
      }
      lPrime.setText(Integer.toString(prime));
      lPrime.setForeground(Color.red);

      return prime;
   }

   public void GeneratePrimes(int rangeMin, int rangeMax) {
      do {
         p1 = generateOnePrime(rangeMax - rangeMin, rangeMin, gui.prime1);
         p2 = generateOnePrime(rangeMax - rangeMin, rangeMin, gui.prime2);
      } while (p1 == p2);
      CalculateProducts();
   }

   public void GeneratePrimes() {
      int sqrt_max = rsaMaxInt;

      do {
         p1 = generateOnePrime(sqrt_max, 0, gui.prime1);
         p2 = generateOnePrime(sqrt_max, 0, gui.prime2);
      } while (p1 == p2);
      CalculateProducts();
   }

   public void GenerateE() throws Exception {
      if (n == 0) {
         throw new Exception("Elbb a prmeket kell ellltani!");
      }
      e = generateRandomE(m, m);
      d = euc.Invert(e, m);
   }

   public boolean GenerateE(int randomE) {
      if (euc.GCD(randomE, m) == 1) {
         e = randomE;
         d = euc.Invert(e, m);
         return true;
      }
      return false;
   }

   public String doEncryptText(String toHide) {
      String hidden = new String();
      Character c;
      numChars = toHide.length();

      encryptedText = new int[numChars];
      for (int i = 0; i < numChars; i++) {
         hidden += Integer.toString(encryptedText[i] = gnp.doGreatNumPow(toHide.charAt(i), e, n)) + " ";
      }

      return hidden;
   }

   public String doDecryptText() {
      String orig = new String();

      for (int i = 0; i < numChars; i++) {
         orig += String.valueOf((char)gnp.doGreatNumPow(encryptedText[i], d, n));
      }

      return orig;
   }

   public void resetRSA() {
      p1 = 0;
      p2 = 0;
      n = 0;
      m = 0;
      e = 0;
      d = 0;
   }
}
